##########################
##第8章　実証分析問題8-A##
##########################

#データの読み込み
income8 <- read.table("8_income.csv", header = TRUE, sep = ",")

##例8.1の再現
#年収を修学年数に回帰
reg1 <- lm(lincome ~ yeduc, data = income8)
summary(reg1)
#本人の修学年数を親の修学年数に回帰
reg2 <- lm(yeduc ~ payeduc, data = income8)
summary(reg2)

#操作変数法を実行するコマンドを含むパッケージ「AER」をインストール
install.packages("AER")
#操作変数法を実行するコマンドを含むパッケージを読み込む
require(AER)

#操作変数を使った回帰
ivreg1 <- ivreg(lincome ~ yeduc | payeduc, data = income8)
summary(ivreg1)


##例8.2の再現
#ミンサー方程式を重回帰で推定
reg3 <- lm(lincome ~ yeduc + exper + exper2, data = income8)
summary(reg3)

#ミンサー方程式を操作変数法で重回帰
ivreg2 <- ivreg(lincome ~ yeduc + exper +exper2 | 
                  exper + exper2 + payeduc, data = income8)
summary(ivreg2)


#例8.3の再現
#修学年数を生まれ月に回帰
reg4 <- lm(yeduc ~ mbirth, data = income8)
summary(reg4)

#誤った操作変数を使って教育の収益率を推定
ivreg3 <- ivreg(lincome ~ yeduc | mbirth, data = income8)
summary(ivreg3)


##例8.4の再現
#修学年数の操作変数として兄弟姉妹数も加えた2段階最小2乗法でミンサー方程式を推定
ivreg4 <- ivreg(lincome ~ yeduc + exper + exper2 | 
                  exper + exper2 + payeduc + sibs, data=income8)
summary(ivreg4)
