#####################################
## 第9章　パネル・データ分析 例9.1 ##
#####################################

#データの読み込み
cig9 <- read.table("9_1_cig_xt.csv", header = TRUE, sep = ",")

#t=1期目（2007年）のデータで，最小2乗法で回帰
reg1 <- lm(ncig ~ life, data = subset(cig9, t==1))
summary(reg1)

#t=2期目（2009年）のデータで，最小2乗法で回帰
reg2 <- lm(ncig ~ life, data = subset(cig9, t==2))
summary(reg2)

#パネル・データ分析用パッケージインストール
install.packages("plm")
#パネル・データ分析用パッケージ読み込み
require(plm)

#1階差分法（fd）を用いて，時間固定効果のない切片なしモデル回帰
preg1 <- plm(ncig ~ life -1, data = cig9, effect = "individual", 
             model = "fd", index = c("id","t"))
summary(preg1)

#データセットで調整のうえで，最小2乗法で回帰する形で1階差分法の実行
#t=1のデータを抽出
cig9_s1 <- subset(cig9, t == 1)
#t=2のデータを抽出
cig9_s2 <- subset(cig9, t == 2)
#t=2とt=1の差分を取る
cig9_ds <- cig9_s2 - cig9_s1
#差分を取ったデータを使って最小2乗法で回帰
reg3 <- lm(ncig ~ life -1, data = cig9_ds)
summary(reg3)
